/***************************************************************************
 *            DataStatsTab.h
 *
 *  Sat Dec 22 16:00:49 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#ifndef _DATASTATSTAB_H
#define _DATASTATSTAB_H

#include <gtkmm.h>

#include "Lince/Utils.h"

class DataStatsTab{
	private:
		Glib::ustring nameTab;
		Gtk::VBox dataWindow;

		float dsValue, usValue, dtValue, utValue;
		float cdsValue, tdsValue, tssValue;

		Gtk::Label downloadedNow, downloadedSession, downloadedTotal;
		Gtk::Label uploadedNow, uploadedSession, uploadedTotal;
		Gtk::Label shareSession, shareTotal;
		Gtk::Label timeSession, timeTotal;

		Gtk::Label currentDownloadingSize, totalDownloadingSize;
		Gtk::Label totalSharedSize, downloadingRatio;

	public:
		DataStatsTab();
		~DataStatsTab();

		void updateDownloadSpeed(float value) { downloadedNow.set_label(Lince::size_to_string(value)); };
		void updateDownloadSession(float value) {
			dsValue = value;
			downloadedSession.set_label(Lince::size_to_string(value));
		};
		void updateDownloadTotal(int64_t value){
			dtValue = (float) value;
			downloadedTotal.set_label(Lince::size_to_string(dtValue));
		}
		void updateUploadSpeed(float value) { uploadedNow.set_label(Lince::size_to_string(value)); };
		void updateUploadSession(float value) {
			usValue = value;
			uploadedSession.set_label(Lince::size_to_string(value));
		};
		void updateUploadTotal(int64_t value){
			utValue = (float) value;
			uploadedTotal.set_label(Lince::size_to_string(utValue));
		};

		void updateCurrentDownloadingSize(int64_t value){
			cdsValue = (float) value;
			currentDownloadingSize.set_label(Lince::size_to_string(cdsValue));
		};

		void updateTotalDownloadingSize(int64_t value){
			tdsValue = (float) value;
			totalDownloadingSize.set_label(Lince::size_to_string(tdsValue));
		};

		void updateTotalSharedSize(int64_t value){
			tssValue = (float) value;
			totalSharedSize.set_label(Lince::size_to_string(tssValue));
		};

		void updateDownloadingRatio();

		void updateShareSession();
		void updateShareTotal();

		void updateTimeSession(double value) { timeSession.set_label(Lince::time_to_string(value)); };
		void updateTimeTotal(double value) { timeTotal.set_label(Lince::time_to_string(value)); };

		const Glib::ustring & getNameTab() { return nameTab; };
		virtual Gtk::Widget * getTabChild(void) { return & dataWindow; };
};

#endif /* _DATASTATSTAB_H */


