/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * InfoNoteBook.cc
 * Copyright (C)  2007 Fernando Tarín Morales
 * icemanf@gmail.com
 *
 * InfoNoteBook.cc is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option)
 * any later version.
 * 
 * InfoNoteBook.cc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with InfoNoteBook.cc.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#include "InfoNoteBook.h"

InfoNoteBook::InfoNoteBook(TorrentInfoTab *tit):
	Gtk::Notebook(),
	generalTab(),
	clientsTab(tit)
{
	set_name("infoNotebook");
	set_border_width(0);
    set_show_tabs(true);
	set_show_border(true);
    set_show_border(false);
	set_scrollable(false);
		
    set_tab_pos(Gtk::POS_TOP);
	
	set_border_width(0);
	property_tab_hborder() = 0;
	property_tab_vborder() = 0;
	property_can_focus() = false;
	
	append_page(*generalTab.getTabChild(), generalTab.getNameTab());
	append_page(*clientsTab.getTabChild(), clientsTab.getNameTab());
	append_page(*filesTab.getTabChild(), filesTab.getNameTab());
	append_page(*piecesTab.getTabChild(), piecesTab.getNameTab());
	append_page(*optionsTab.getTabChild(), optionsTab.getNameTab());
	
	updatingData = false;
}

void InfoNoteBook::updateInfoNoteBook(Lince::Torrent *t){
	updatingDataMutex.lock();
	if (updatingData){
		updatingDataCond.wait(updatingDataMutex);
	}
	updatingData = true;
	
	static int updateClients=0;
	generalTab.updateGeneralInfoNoteBookTab(t);
	
	if (!(updateClients % 5))
	{
		clientsTab.updateClientsInfoNoteBookTab(t);
		updateClients = 0;
	}
	updateClients++;
	
	filesTab.updateFilesInfoNoteBookTab(t);
	piecesTab.updatePiecesInfoNoteBookTab(t);
	optionsTab.updateOptionsInfoNoteBookTab(t);
		
	updatingData = false;
	updatingDataCond.signal();
	updatingDataMutex.unlock();	
}

InfoNoteBook::~InfoNoteBook(){
}
