/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * InfoNoteBook.cc
 * Copyright (C)  2007 Fernando Tarín Morales
 * icemanf@gmail.com 
 *
 * InfoNoteBook.cc is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option)
 * any later version.
 * 
 * InfoNoteBook.cc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with InfoNoteBook.cc.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef _INFONOTEBOOK_H_
#define _INFONOTEBOOK_H_

#include <gtkmm.h>

#include "libtorrent/session.hpp"

#include "GeneralInfoNoteBookTab.h"
#include "ClientsInfoNoteBookTab.h"
#include "FilesInfoNoteBookTab.h"
#include "PiecesInfoNoteBookTab.h"
#include "OptionsInfoNoteBookTab.h"
#include "Utils.h"

#include "Lince/Torrent.h"

class TorrentInfoTab;

class InfoNoteBook: public Gtk::Notebook{
	private:
		int last_page;
		GeneralInfoNoteBookTab generalTab;
		ClientsInfoNoteBookTab clientsTab;
		FilesInfoNoteBookTab filesTab;
		PiecesInfoNoteBookTab piecesTab;
		OptionsInfoNoteBookTab optionsTab;
	
		// Make sure that updating data is thread safe
		bool updatingData;
		Glib::Cond updatingDataCond;
		Glib::Mutex updatingDataMutex;
		
	public:		
		InfoNoteBook(TorrentInfoTab *);
		~InfoNoteBook();
	
		void updateInfoNoteBook(Lince::Torrent *);
};

#endif // _INFONOTEBOOK_H_
